/*
 * Instance header file for PIC32CZ8110CA90208
 *
 * Copyright (c) 2024 Microchip Technology Inc. and its subsidiaries.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

/* file generated from device description file (ATDF) version 2024-07-31T17:51:00Z */
#ifndef _PIC32CZCA90_TCC2_INSTANCE_
#define _PIC32CZCA90_TCC2_INSTANCE_


/* ========== Instance Parameter definitions for TCC2 peripheral ========== */
#define TCC2_CC_NUM                              (6)        /* Number of Compare/Capture units */
#define TCC2_DITHERING                           (1)        /* Dithering feature implemented */
#define TCC2_DMAC_ID_MC_0                        (44)       /* Indexes of DMA Match/Compare triggers 0 */
#define TCC2_DMAC_ID_MC_1                        (45)       /* Indexes of DMA Match/Compare triggers 1 */
#define TCC2_DMAC_ID_MC_2                        (46)       /* Indexes of DMA Match/Compare triggers 2 */
#define TCC2_DMAC_ID_MC_3                        (47)       /* Indexes of DMA Match/Compare triggers 3 */
#define TCC2_DMAC_ID_MC_4                        (48)       /* Indexes of DMA Match/Compare triggers 4 */
#define TCC2_DMAC_ID_MC_5                        (49)       /* Indexes of DMA Match/Compare triggers 5 */
#define TCC2_DMAC_ID_OVF                         (43)       /* DMA overflow/underflow/retrigger trigger */
#define TCC2_DTI                                 (1)        /* Dead-Time-Insertion feature implemented */
#define TCC2_GCLK_ID                             (33)       /* Index of Generic Clock */
#define TCC2_INSTANCE_ID                         (35)       /* Instance index for TCC2 */
#define TCC2_MASTER_SLAVE_MODE                   (0)        /* TCC type 0 : NA, 1 : Master, 2 : Slave */
#define TCC2_MCLK_ID_APB                         (43)       /* Index for TCC2 APB clock */
#define TCC2_OTMX                                (1)        /* Output Matrix feature implemented */
#define TCC2_OW_NUM                              (6)        /* Number of Output Waveforms */
#define TCC2_PAC_ID                              (35)       /* Index for TCC2 registers write protection */
#define TCC2_PG                                  (1)        /* Pattern Generation feature implemented */
#define TCC2_SIZE                                (32)       
#define TCC2_SWAP                                (1)        /* DTI outputs swap feature implemented */

#endif /* _PIC32CZCA90_TCC2_INSTANCE_ */
