/*
 * Instance header file for PIC32CZ8110CA90208
 *
 * Copyright (c) 2024 Microchip Technology Inc. and its subsidiaries.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

/* file generated from device description file (ATDF) version 2024-07-31T17:51:00Z */
#ifndef _PIC32CZCA90_TCC8_INSTANCE_
#define _PIC32CZCA90_TCC8_INSTANCE_


/* ========== Instance Parameter definitions for TCC8 peripheral ========== */
#define TCC8_CC_NUM                              (2)        /* Number of Compare/Capture units */
#define TCC8_DITHERING                           (1)        /* Dithering feature implemented */
#define TCC8_DMAC_ID_MC_0                        (66)       /* Indexes of DMA Match/Compare triggers 0 */
#define TCC8_DMAC_ID_MC_1                        (67)       /* Indexes of DMA Match/Compare triggers 1 */
#define TCC8_DMAC_ID_OVF                         (65)       /* DMA overflow/underflow/retrigger trigger */
#define TCC8_DTI                                 (1)        /* Dead-Time-Insertion feature implemented */
#define TCC8_GCLK_ID                             (39)       /* Index of Generic Clock */
#define TCC8_INSTANCE_ID                         (41)       /* Instance index for TCC8 */
#define TCC8_MASTER_SLAVE_MODE                   (0)        /* TCC type 0 : NA, 1 : Master, 2 : Slave */
#define TCC8_MCLK_ID_APB                         (49)       /* Index for TCC8 APB clock */
#define TCC8_OTMX                                (0)        /* Output Matrix feature implemented */
#define TCC8_OW_NUM                              (2)        /* Number of Output Waveforms */
#define TCC8_PAC_ID                              (41)       /* Index for TCC8 registers write protection */
#define TCC8_PG                                  (0)        /* Pattern Generation feature implemented */
#define TCC8_SIZE                                (32)       
#define TCC8_SWAP                                (1)        /* DTI outputs swap feature implemented */

#endif /* _PIC32CZCA90_TCC8_INSTANCE_ */
