/*
 * Instance header file for PIC32CZ8110CA90208
 *
 * Copyright (c) 2024 Microchip Technology Inc. and its subsidiaries.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

/* file generated from device description file (ATDF) version 2024-07-31T17:51:00Z */
#ifndef _PIC32CZCA90_TCC4_INSTANCE_
#define _PIC32CZCA90_TCC4_INSTANCE_


/* ========== Instance Parameter definitions for TCC4 peripheral ========== */
#define TCC4_CC_NUM                              (2)        /* Number of Compare/Capture units */
#define TCC4_DITHERING                           (1)        /* Dithering feature implemented */
#define TCC4_DMAC_ID_MC_0                        (54)       /* Indexes of DMA Match/Compare triggers 0 */
#define TCC4_DMAC_ID_MC_1                        (55)       /* Indexes of DMA Match/Compare triggers 1 */
#define TCC4_DMAC_ID_OVF                         (53)       /* DMA overflow/underflow/retrigger trigger */
#define TCC4_DTI                                 (1)        /* Dead-Time-Insertion feature implemented */
#define TCC4_GCLK_ID                             (35)       /* Index of Generic Clock */
#define TCC4_INSTANCE_ID                         (37)       /* Instance index for TCC4 */
#define TCC4_MASTER_SLAVE_MODE                   (0)        /* TCC type 0 : NA, 1 : Master, 2 : Slave */
#define TCC4_MCLK_ID_APB                         (45)       /* Index for TCC4 APB clock */
#define TCC4_OTMX                                (1)        /* Output Matrix feature implemented */
#define TCC4_OW_NUM                              (2)        /* Number of Output Waveforms */
#define TCC4_PAC_ID                              (37)       /* Index for TCC4 registers write protection */
#define TCC4_PG                                  (1)        /* Pattern Generation feature implemented */
#define TCC4_SIZE                                (32)       
#define TCC4_SWAP                                (1)        /* DTI outputs swap feature implemented */

#endif /* _PIC32CZCA90_TCC4_INSTANCE_ */
