/*
 * Instance header file for PIC32CZ8110CA90208
 *
 * Copyright (c) 2024 Microchip Technology Inc. and its subsidiaries.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */

/* file generated from device description file (ATDF) version 2024-07-31T17:51:00Z */
#ifndef _PIC32CZCA90_TCC9_INSTANCE_
#define _PIC32CZCA90_TCC9_INSTANCE_


/* ========== Instance Parameter definitions for TCC9 peripheral ========== */
#define TCC9_CC_NUM                              (6)        /* Number of Compare/Capture units */
#define TCC9_DITHERING                           (1)        /* Dithering feature implemented */
#define TCC9_DMAC_ID_MC_0                        (69)       /* Indexes of DMA Match/Compare triggers 0 */
#define TCC9_DMAC_ID_MC_1                        (70)       /* Indexes of DMA Match/Compare triggers 1 */
#define TCC9_DMAC_ID_MC_2                        (71)       /* Indexes of DMA Match/Compare triggers 2 */
#define TCC9_DMAC_ID_MC_3                        (72)       /* Indexes of DMA Match/Compare triggers 3 */
#define TCC9_DMAC_ID_MC_4                        (73)       /* Indexes of DMA Match/Compare triggers 4 */
#define TCC9_DMAC_ID_MC_5                        (74)       /* Indexes of DMA Match/Compare triggers 5 */
#define TCC9_DMAC_ID_OVF                         (68)       /* DMA overflow/underflow/retrigger trigger */
#define TCC9_DTI                                 (1)        /* Dead-Time-Insertion feature implemented */
#define TCC9_GCLK_ID                             (40)       /* Index of Generic Clock */
#define TCC9_INSTANCE_ID                         (42)       /* Instance index for TCC9 */
#define TCC9_MASTER_SLAVE_MODE                   (0)        /* TCC type 0 : NA, 1 : Master, 2 : Slave */
#define TCC9_MCLK_ID_APB                         (50)       /* Index for TCC9 APB clock */
#define TCC9_OTMX                                (1)        /* Output Matrix feature implemented */
#define TCC9_OW_NUM                              (6)        /* Number of Output Waveforms */
#define TCC9_PAC_ID                              (42)       /* Index for TCC9 registers write protection */
#define TCC9_PG                                  (1)        /* Pattern Generation feature implemented */
#define TCC9_SIZE                                (32)       
#define TCC9_SWAP                                (1)        /* DTI outputs swap feature implemented */

#endif /* _PIC32CZCA90_TCC9_INSTANCE_ */
